/*
fzem/fzem_fuzz.c
02.25.2009
fzem

    Krakow Labs Development [www.krakowlabs.com] -> fzem
             "MUA security just met its match"
        rush@KL (Jeremy Brown) [rush@krakowlabs.com]

Core Header -> fzem.tar.gz

Associated Files & Information:
http://www.krakowlabs.com/dev/fuz/fzem/fzem
http://www.krakowlabs.com/dev/fuz/fzem/fzem.c.txt
http://www.krakowlabs.com/dev/fuz/fzem/fzem_fuzz.c.txt
http://www.krakowlabs.com/dev/fuz/fzem/core.h.txt
http://www.krakowlabs.com/dev/fuz/fzem/fuzz.h.txt
http://www.krakowlabs.com/dev/fuz/fzem/Makefile.txt
http://www.krakowlabs.com/dev/fuz/fzem/fzem_doc.txt
http://www.krakowlabs.com/dev/fuz/fzem/fzem.tar.gz
http://www.krakowlabs.com/dev/fuz/fzem/fzem.jpeg
fzem/fzem_fuzz.c
*/

#define SMTP_OK    250
#define SMTP_ERR   500

#define SMTP_BEGIN_RESP 220
#define SMTP_DATA_RESP  354
#define SMTP_QUIT_RESP  221

#define POP_OK  "+OK"
#define POP_ERR "-ERR"

#define IMAP_BEGIN "* OK"
#define IMAP_OK    "OK"
#define IMAP_ERR   "NO"
#define IMAP_QUIT  "BYE"

#define POP_OK_BEGIN         "+OK fzem POP3 server ready <fz@em>\r\n"
#define POP_OK_LOGIN_RESP    "+OK user accepted\r\n"
#define POP_OK_LOGIN_SUCCESS "+OK maildrop has new mail\r\n"
#define POP_ERR_AUTH_RESP    "-ERR AUTH not accepted\r\n"
#define POP_ERR_STLS_RESP    "-ERR STLS not accepted\r\n"
#define POP_OK_CAPA_RESP     "+OK Capability list\r\nUSER\r\nAPOP\r\n.\r\n"
#define POP_OK_UIDL_RESPA    "+OK\r\n"
#define POP_OK_UIDL_RESPB    ".\r\n"
#define POP_OK_DELE_RESP     "+OK message deleted\r\n"
#define POP_OK_STAT_RESP     "+OK 276 27600\r\n"
#define POP_OK_LIST_RESPA    "+OK 276 messages (27600 octets)\r\n"
#define POP_OK_LIST_RESPB    ".\r\n"
#define POP_OK_QUIT_RESP     "+OK fzem POP3 server signing off\r\n"

#define POP_HDR_ST_CUSTOM     "+OK 1 100\r\n"
#define POP_HDR_LT_CUSTOM     "+OK 1 message (100 octets)\r\n1 100\r\n.\r\n"
#define POP_HDR_UL_CUSTOM     "+OK\r\n1 w00t00w00t00w00t00w00t00w\r\n.\r\n"

#define MAILHDRTLONE 11
#define MAILHDRTLTWO 9
#define MIMEHDRTL    13

#define HDRTL        33

#define POP_HDRS        1
#define POP_HDRS_CUSTOM 2

#define BUFSIZE 1024

void fzem_smtp_resp(char *buf, int cli, int cnum, char *cfd, int r);
void fzem_pop_hdrs(char *buf, int cli);
void fzem_pop_hdrs_custom(char *buf, int cli, int cnum, int hnum, char *cfd, char *chd);
void fzem_pop_resp(char *buf, int cli, int cnum, char *cfd, int r);
void fzem_imap_resp(char *buf, int cli, int cnum, char *cfd, int r);

void fzem_smtp_resp_hlpr(char *buf, int cli, char *resp, int len, char *data, int r);
void fzem_pop_hdrs_hlpr_one(char *buf, int cli, int z);
void fzem_pop_hdrs_hlpr_two(char *buf, int cli);
void fzem_pop_resp_hlpr(char *buf, int cli, char *resp, int len, char *data, int r);
void fzem_imap_resp_hlpr(char *buf, int cli, char *resp, int len, char *data, int r);

void fzem_pop_hdrs_stage1(char *buf, int cli, int n);
void fzem_pop_hdrs_stage2(char *buf, int cli, int n);
void fzem_pop_hdrs_stage3(char *buf, int cli, int n);
void fzem_pop_hdrs_stage_hlpr(char *buf, int cli, char *data, int len);

void fzem_counter(int *cnum);
void fzem_fzof_gen(void);

struct
{

     char *header;

}

mail[] = // (20 AVAILABLE) Mail Header Fields, Ref: RFC 4021
{

     {"Date:"},
     {"From:"},
     {"Sender:"},
     {"Reply-To:"},
     {"To:"},
     {"Cc:"},
     {"Bcc:"},
     {"Message-ID:"},
     {"In-Reply-To:"},
     {"References:"},
     {"Subject:"},
     {"Comments:"},
     {"Keywords:"},
     {"Return-Path:"},
     {"Received:"},
     {"Encrypted:"},
     {"Accept-Language:"},
     {"Encoding:"},
     {"Expires:"},
     {"Language:"},

};

struct
{

     char *header;

}

mime[] = // (13 TOTAL AVAILABLE) MIME Header Fields, Ref: RFC 4021
{

     {"MIME-Version:"},
     {"Content-ID:"},
     {"Content-Description:"},
     {"Content-Transfer-Encoding:"},
     {"Content-Type:"},
     {"Content-Base:"},
     {"Content-Location:"},
     {"Content-features:"},
     {"Content-Disposition:"},
     {"Content-Language:"},
     {"Content-Alternative:"},
     {"Content-MD5:"},
     {"Content-Duration:"},

};
